<?php
include "functions.php";
include ($config['jpgraph_path'] . "/jpgraph.php");
include ($config['jpgraph_path'] . "/jpgraph_line.php");
$port = ($HTTP_GET_VARS['port']);
$proto = ($HTTP_GET_VARS['proto']);
$offset = ($HTTP_GET_VARS['offset']);
$limit = ($HTTP_GET_VARS['limit']);
$portname = resolvePort($port, $proto);

if ( $portname != $port ) {
	$portname = $portname . "  (" . $port . ")";
}       


////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////
///  Database part
////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////
if ($HTTP_GET_VARS['proto'] == "ICMP") {
	$field = "typeCode";
} elseif ($HTTP_GET_VARS['proto'] == "IP") {
	$field = "proto";
} else {
	$field = "port";
}

$sqlquery = "SELECT date,totalRecords,totalSrcs,totalDsts FROM trends" . $proto . " WHERE " . $field . "='" .  $port;
$sqlquery .= "' GROUP BY date ORDER BY date DESC LIMIT " . $offset . "," . $limit;
$result= $GLOBALS['dbh']->query($sqlquery);

// Error Checking
if (DB::isError($result)) {
	print "<B>SQL QUERY:</B> " . $sqlquery . "<BR><BR>\n";
	die("SELECT failed: " . $result->getMessage () . "\n");
}

while($row = $result->fetchRow()){
        $fdatax[] = $row[0];		// Dates
        $fydata[] = $row[2];		// Sources
        $fy2data[] = $row[3];		// Destinations
}
$GLOBALS['dbh']->disconnect();

$datax = array_reverse($fdatax);
$ydata = array_reverse($fydata);
$y2data = array_reverse($fy2data);

////////////////////////////////////////////////////////////////////////////
// Validate the data
////////////////////////////////////////////////////////////////////////////
$datax_count = count($datax);
if ($datax_count < 2) {
	unset($datax);
	unset($ydata);
	unset($y2data);
	$datax = array("1","2");
	$ydata = array(0,0);
	$y2data = array(0,0);
	$nodata = 1;		// Set nodata flag
}

////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////
///  JPGraph part
////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////
$graph = new Graph(550,300,"auto");	
$graph->img->SetMargin(70,110,20, 85);
$graph->SetScale("textlin");
$graph->SetY2Scale("lin");
$graph->SetShadow();

// Create the linear plot
$lineplot=new LinePlot($ydata);
$lineplot2=new LinePlot($y2data);

$graph->yaxis->scale->ticks->SupressFirst();
$graph->y2axis->scale->ticks->SupressFirst();

// Add the plot to the graph
$graph->Add($lineplot);
$graph->AddY2($lineplot2);

$graph->title->Set($proto . ": " . $portname);
$graph->yaxis->title->Set("Sources");
$graph->yaxis->SetTitleMargin(50);
$graph->y2axis->title->Set("Targets");
$graph->y2axis->SetTitleMargin(50);

$graph->title->SetFont(FF_FONT1,FS_BOLD);
$graph->yaxis->title->SetFont(FF_FONT1,FS_BOLD);
$graph->y2axis->title->SetFont(FF_FONT1,FS_BOLD);
$graph->xaxis->SetFont(FF_ARIAL,FS_NORMAL,8);
$graph->xaxis->title->Set("Generated by: SensorTrends");
$graph->xaxis->SetTitleMargin(55);
$graph->xaxis->SetLabelAngle(90);		// Angle text


$lineplot->SetColor("blue");
$lineplot->SetWeight(2);

if ($nodata) {					// Dont show for null data
	$lineplot2->SetColor("gray");
} else {
	$lineplot2->SetColor("green");
}
$lineplot2->SetWeight(2);

if (! $nodata ) {				// Dont show legend for null data
	$lineplot->SetLegend("Sources");
	$lineplot2->SetLegend("Targets");
	$graph->legend->Pos(0.02,0.8,"right","center");
}

$graph->xaxis->SetTickLabels($datax);
//$tickInterval = (int)(count($datax)/2);
//$tickInterval = (int)((45 / 2) / 2);
//print "tickInterval: " . $tickInterval . "<P>\n";
//$graph->xaxis->SetTextTickInterval($tickInterval);
$graph->xaxis->SetTextTickInterval(2);

// Display the graph
$graph->Stroke();
?>
